/********************************************************           
 * meta -- program to add metadata from a file tree     * 
 *         replica.                                     * 
 *                                                      *   
 * Author:  Jaakko Lappalainen - 2011                   *   
 * email: jaakko@torroja.dmt.upm.es                     *   
 *                                                      *   
 ********************************************************/  

#include "meta.h"

extern int line, col;
extern char *yytext;
extern FILE *yyin;
extern int yyparse();
extern FILE *out;
char target[50];
char cmd[MAX_STR];
//char rootName[50];

int execCmd(char *s, const char* format, ...){
	char x[MAX_STR];
	strcpy(x,"\0");
	va_list args;
  	va_start(args, format);
	//fprintf(stderr, "s: %s\n", s);
	sprintf(x, s, format, args);
	fprintf(stderr, "comando: %s\n",x);
/*	if( system(x) != 0 ){
		fprintf(stderr, "Error executing %s\n", x);
		return -1;
	}*/
	return 0;
}

int endsTgz(char *s){
	return (s[strlen(s)-4] == '.' &&
		s[strlen(s)-3] == 't' && 
		s[strlen(s)-2] == 'g'&&
		s[strlen(s)-1] == 'z');
}

int endsTarDotGz(char *s){
	return (s[strlen(s)-7] == '.' &&
		s[strlen(s)-6] == 't' &&		
		s[strlen(s)-5] == 'a' &&		
		s[strlen(s)-4] == 'r' &&
		s[strlen(s)-3] == '.' && 
		s[strlen(s)-2] == 'g'&&
		s[strlen(s)-1] == 'z');
}

int isCompressed(char *s){
	return endsTarDotGz(s) || endsTgz(s);
}

int isRelativePath(char *s){
	return (s[0] == s[1] && s[1] == '.');
}

int main(int argc, char **argv)
{	
//	rootName = NULL;
//	target = NULL;

	if(argc == 3){

		/*if(isRelativePath(argv[2])){
			fprintf(stderr, "No relative path allowed.\n");
			return -1;
		}

		if(isCompressed(argv[2])){
			if(endsTarDotGz(argv[2])){
				//rootName = (char *)malloc(sizeof(char)*strlen(argv[2]));
				strncpy(rootName, argv[2], strlen(argv[2])-7);
			}
			if(endsTgz(argv[2])){
				//rootName = (char *)malloc(sizeof(char)*strlen(argv[2]));
				strncpy(rootName, argv[2], strlen(argv[2])-4);
			}
		}*/
		
		
		
		//fprintf(stderr, "Decompressing %s...", argv[2]);
		//execCmd("tar -zxf %s", argv[2]);
		//fprintf(stderr, " OK.\n");
		//execCmd("find %s > input",rootName); 
		
		if ((yyin = fopen(argv[2], "r")) == NULL){
			fprintf(stderr, "fopen: Input file error\n");
			return -1;
		}
	
		sprintf(cmd, "%s.log", argv[1]);

		if ((out = fopen(cmd, "w")) == NULL){
			fprintf(stderr, "fopen: Output file error\n");
			return -1;
		}
	}
	
	else{
		printf("usage: meta <machine> <gen-out-file>\n");
		return -1;
	}

	fprintf(stdout, "\n-------------------------------------------------------------\n");
	fprintf(stdout, "  meta - program to add metadata\n\tfrom a file tree replica automatically.\n\n\t* Author: Jaakko Lappalainen\n\t* Year: 2011\n\t* Email: jaakko@torroja.dmt.upm.es\n");
	fprintf(stdout, "-------------------------------------------------------------\n\n");

	//target = (char*) malloc(sizeof(char)*strlen(argv[1]));

	strcpy(target, argv[1]);

	if ((yyparse()) != TOK_ERROR) {
	}
	
	fprintf(stdout, "\n\n* See standard output for errors, %s.log file for for further information.\n\n",argv[1]);

	if(argc == 3){
		fclose(yyin);
		fclose(out);
	}

	//free(target);
	//free(rootName);
	return 0;
}
