%{

#include "meta.h"

extern int yylex();
extern char *yytext;
extern char target[50];


FILE *out;
char size[10];
char name[MAX_STR];
struct stat fileData; 
int line, col;
//char str[MAX_STR];
long int dirs, files;
char cmd[MAX_STR];


int yyerror(char *s) {
	printf("Syntax error:%d:%d: (\"%s\")\n", line, col, yytext);
	return -1;
}
/*
int findFromLast(char *s, char c){
	int i=strlen(s);
	while(i>=0){
		if(s[i]==c)
			return i;
		i--;
	}
	return -1;
}

int isFile(char *s){
	int i = findFromLast(s, ':');
	int j = findFromLast(s, '[');
	int k = findFromLast(s, ']');
	//printf("%s %d, %d, %d\n", s, i,j,k);
	return (i > 0 && j > 0 && k > 0
		&& i+1==j && j+1 < k && k == strlen(s)-1);
}

char * getSize(char *s, char *t){
	int i=findFromLast(t, '[');
	int j=findFromLast(t, ']');
	int k=0;
	int l=0;
	for(k=i+1; k<j; k++){
		s[l]=t[k];
		l++;
	}
	s[l]='\0';
	return s;
}

char * getName(char *s, char *t){
	int i=findFromLast(t, ':');
	int j;
	for(j = 0; j < i; j++)
		s[j] = t[j];
	s[j]='\0';
	return s; 
}
static uintmax_t unsigned_file_size (off_t size)
{
  return size + (size < 0) * ((uintmax_t) INT_MAX - INT_MIN + 1);
}*/
%}

%union {
	att a;  
}

%token TOK_STR;
%token TOK_CR;

%type <a> LIST
%type <a> LINE
%type <a> STR

%%
INICIO: start LIST end {};

start: {
	files = dirs = 0;
	fprintf(out, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	/*Add more pre-meta info 'fprintfs' only above this comment */
	fprintf(out, "Logging into iRODS... ");

	if(system("iinit")!=0)
		fprintf(out, "FAILED\n\n");
	else
		fprintf(out, "OK.\n\n");

};

LIST : LIST LINE {} | LINE {};

LINE : STR TOK_CR STR TOK_CR {
		//fprintf(stderr, "$1.lexeme: %s $3.lexeme: %s\n", $1.lexeme, $3.lexeme);
		if(strcmp($3.lexeme,"DIR")!=0){
			//execCmd("touch ./%s%s",target,$1.lexeme);
			sprintf(cmd, "touch ./%s%s",target,$1.lexeme);
			if(system(cmd) != 0){
				fprintf(stderr, "Error executing %s\n",cmd);
				return -1;
			}
			//execCmd("iput -f ./%s%s /fluidMec/home/rods",target,$1.lexeme);
			sprintf(cmd, "iput -f ./%s%s /fluidMec/home/rods/%s%s", target, $1.lexeme, target, $1.lexeme);
			if(system(cmd) != 0){
                                fprintf(stderr, "Error executing %s\n",cmd);
                                return -1;
                        }
			//fprintf(stderr, "touch ./%s%s\n",target,$1.lexeme);
   			//fprintf(stderr, "iput -f ./%s%s /fluidMec/home/rods/%s%s\n",target,$1.lexeme, target, $1.lexeme);
			fprintf(out, "putting: %s /fluidMec/home/rods\n",$1.lexeme);

			//execCmd("imeta -d /fluidMec/home/rods/%s/%s fileSize %s",target, $1.lexeme,$3.lexeme);
			sprintf(cmd, "imeta -d add /fluidMec/home/rods/%s%s fileSize %s",target, $1.lexeme,$3.lexeme);
			if(system(cmd) != 0){
                                fprintf(stderr, "Error executing %s\n",cmd);
                                return -1;
                        }
			fprintf(out, "metadata: /fluidMec/home/rods/%s/%s fileSize %s",target, $1.lexeme,$3.lexeme);
			//fprintf(stderr, "imeta -d /fluidMec/home/rods/%s/%s fileSize %s\n",target, $1.lexeme,$3.lexeme);			

			files++;
		}
		else{		
			fprintf(out, "Collection:[%s]\n",$1.lexeme);
			//execCmd("mkdir -p ./%s/%s",target,$1.lexeme);	
			sprintf(cmd, "mkdir -p ./%s/%s",target,$1.lexeme);
			if(system(cmd) != 0){
                                fprintf(stderr, "Error executing %s\n",cmd);
                                return -1;
                        }
			//execCmd("imkdir -p /fluidMec/home/rods/%s/%s",target, $1.lexeme);
			sprintf(cmd,"imkdir -p /fluidMec/home/rods/%s/%s",target, $1.lexeme);
                        if(system(cmd) != 0){
				fprintf(stderr, "Error executing %s\n",cmd);
                                return -1;
			}
			/*sprintf(cmd,"icd /fluidMec/home/rods/%s/%s",target, $1.lexeme);
                        if(system(cmd) != 0){
                                fprintf(stderr, "Error executing %s\n",cmd);
                                return -1;
                        }*/
			//fprintf(stderr, "mkdir -p ./%s/%s\n",target,$1.lexeme);
			//fprintf(stderr, "imkdir -p /fluidMec/home/rods/%s/%s\n",target, $1.lexeme);
			dirs++;
		}
};

STR : TOK_STR {};
end: { 
	//system("icd");
                       
                                
	//rewind(out);
	fprintf(out, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	/*Add more pre-meta info 'fprintfs' only above this comment */
	fprintf(out, "Success generations: ");
	fprintf(out, "%ld directories, %ld files\n",dirs, files);
	/*Add more post-meta info 'fprintfs' only below this comment */
	fprintf(out, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
};


